/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Interval
 */

public class Interval {
  @JsonProperty("every")
  private Integer every = null;

  /**
   * The period/interval type
   */
  public enum PeriodEnum {
    DAYS("days"),
    
    HOURS("hours"),
    
    MINUTES("minutes"),
    
    SECONDS("seconds"),
    
    MICROSECONDS("microseconds");

    private String value;

    PeriodEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PeriodEnum fromValue(String text) {
      for (PeriodEnum b : PeriodEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("period")
  private PeriodEnum period = null;

  public Interval every(Integer every) {
    this.every = every;
    return this;
  }

   /**
   * The interval without unit
   * @return every
  **/
  @ApiModelProperty(required = true, value = "The interval without unit")
  public Integer getEvery() {
    return every;
  }

  public void setEvery(Integer every) {
    this.every = every;
  }

  public Interval period(PeriodEnum period) {
    this.period = period;
    return this;
  }

   /**
   * The period/interval type
   * @return period
  **/
  @ApiModelProperty(example = "days", required = true, value = "The period/interval type")
  public PeriodEnum getPeriod() {
    return period;
  }

  public void setPeriod(PeriodEnum period) {
    this.period = period;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Interval interval = (Interval) o;
    return Objects.equals(this.every, interval.every) &&
        Objects.equals(this.period, interval.period);
  }

  @Override
  public int hashCode() {
    return Objects.hash(every, period);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Interval {\n");

    sb.append("    every: ").append(toIndentedString(every)).append("\n");
    sb.append("    period: ").append(toIndentedString(period)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

